/*
 *************************************************************************
 *                                                                       *
 * Copyright 2000 Compaq Computer Corporation                            *
 *                                                                       *
 * COMPAQ Registered in U.S. Patent and Trademark Office.                *
 *                                                                       *
 *************************************************************************
 * IMPORTANT: Carefully read the License Terms below before              *
 * proceeding.  By use of these materials you agree to these terms.      *
 * If you do not agree to these terms, you may not use this software or  *
 * the accompanying documentation.                                       *
 *************************************************************************
 * LICENSE TERMS                                                         *
 * 1. GRANT                                                              *
 * Compaq Computer Corporation ("COMPAQ") grants you the right to use,   *
 * modify, and distribute the following source code (the "Software")     *
 * on any number of computers. You may use the Software as part of       *
 * creating a software program or product intended for commercial or     *
 * non-commercial distribution in machine-readable source code, binary,  *
 * or executable formats. You may distribute the Software as             *
 * machine-readable source code provided this license is not removed     *
 * from the Software and any modifications are conspicuously indicated.  *
 * 2. COPYRIGHT                                                          *
 * The Software is owned by COMPAQ and its suppliers and is protected by *
 * copyright laws and international treaties.  Your use of the Software  *
 * and associated documentation is subject to the applicable copyright   *
 * laws and the express rights and restrictions of these terms.          *
 * 3. RESTRICTIONS                                                       *
 * You may not remove any copyright, trademark, or other proprietary     *
 * notices from the Software or the associated  documentation.           *
 * You are responsible for compliance with all applicable export or      *
 * re-export control laws and regulations if you export the Software.    *
 * This license is governed by and is to be construed under the laws     *
 * of the State of Texas.                                                *
 *                                                                       *
 * DISCLAIMER OF WARRANTY AND LIABILITY                                  *
 * Compaq shall not be liable for technical or editorial errors or       *
 * omissions contained herein. The information contained herein is       *
 * subject to change without notice.                                     *
 *                                                                       *
 * THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.       *
 * THE ENTIRE RISK ARISING OUT OF THE USE OF THIS SOFTWARE REMAINS WITH  *
 * RECIPIENT.  IN NO EVENT SHALL COMPAQ BE LIABLE FOR ANY DIRECT,        *
 * CONSEQUENTIAL, INCIDENTAL, SPECIAL, PUNITIVE OR OTHER DAMAGES         *
 * WHATSOEVER (INCLUDING WITHOUT LIMITATION DAMAGES FOR LOSS OF BUSINESS *
 * PROFITS, BUSINESS INTERRUPTION, OR LOSS OF BUSINESS INFORMATION),     *
 * EVEN IF COMPAQ HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES    *
 * AND WHETHER IN AN ACTION OF CONTRACT OR TORT INCLUDING NEGLIGENCE.    *
 *                                                                       *
 * If you have any questions concerning this license, please contact:    *
 * Compaq Computer Corporation, Software Business Practices, ZKO1-2/D22, *
 * 110 Spit Brook Road, Nashua, NH. 03062-2698.                          *
 *                                                                       *
 *************************************************************************
 */

/*
**  Include Files
*/
#include "vms_jackets.h"
#include <stdio>
#include <stdlib>
#include <ssdef>
#include <descrip>
#include <iodef>
#include <starlet>
#include <ttdef>

struct  dev_char                        /* Device characteristics block      
*/
{
unsigned char   class;
unsigned char   type;
short   int     buffer_size;
unsigned int    basic_chars;
unsigned int    extended_chars;
};

struct  IOSB                            /* Standard I/O status block         
*/
{
short   int     status;
short   int     byte_cnt;
int             unused;
};

/* flag set means turn echo off */
int GENERIC_NOECHO(long chan, int flag) {

    int status;

    struct IOSB iosb ;
    struct  dev_char chars;

    /* Get current chars */
    status = sys$qiow (0, chan, IO$_SENSEMODE, &iosb, 0, 0,
                       &chars, sizeof(chars), 0, 0, 0,
                       0);
#ifdef DEBUG
    printf("status = %d,", status);
    printf("IOSB status = %d\n", iosb.status);
#endif
    if ( !( status & 1) ) exit(status);
    if ( !( iosb.status & 1) ) exit(iosb.status);

    /* Set the ECHO bit accordingly */
    chars.basic_chars |= TT$M_NOECHO ;
    if (!flag) chars.basic_chars ^= TT$M_NOECHO ;

    /* Now set the chars */
    status = sys$qiow (0, chan, IO$_SETMODE, &iosb, 0, 0,
                       &chars, sizeof(chars), 0, 0, 0,
                       0);
#ifdef DEBUG
    printf("status = %d,", status);
    printf("IOSB status = %d\n", iosb.status);
#endif
    if ( !( status & 1) ) exit(status);
    if ( !( iosb.status & 1) ) exit(iosb.status);
    return 0;
}
#ifdef BUILD_MAIN 
int main() {

long channel;
int status;
char line[100];
    
$DESCRIPTOR(device, "SYS$INPUT:");

status = sys$assign(&device,&channel,0,0,0);
if ( !( status & 1) ) exit(status);

printf("First read is before we change anything\n");
gets(line); printf("You entered: %s\n\n",line);

NoEcho(channel,1);

printf("Second read is with echo turned off\n");
gets(line); printf("You entered: %s\n\n",line);

NoEcho(channel,0);

printf("Third read is with echo turned back on\n");
gets(line); printf("You entered: %s\n\n",line);

status = sys$dassgn(channel);
if ( !( status & 1) ) exit(status);


exit(0);
}
#endif 

